<?php
namespace dxkite\confession\wall\controller;

use dxkite\confession\wall\table\ConfessionTable;
use dxkite\support\view\TablePager;

/**
 * 处理表白
 */
class ConfessionController
{
    protected $table;

    public function __construct()
    {
        $this->table = new ConfessionTable;
    }

    /**
     * 添加表白帖
     *
     * @param string $title
     * @param string $content
     * @param boolean $anonymous
     * @return integer
     */
    public function add(string $title, string $content, bool $anonymous=true): int
    {
        return $this->table->insert([
            'user' => get_user_id(),
            'title' => $title ,
            'content' => $content,
            'anonymous' => $anonymous ? 1 :0,
            'time' => time(),
            'ip' => request()->ip(),
            'status' => ConfessionTable::STATUS_NORMAL,
        ]);
    }


    public function list(?int $page, int $row = 10):?array
    {
        //  列出表元素，当状态为：ConfessionTable::STATUS_NORMAL 的时候
        return TablePager::listWhere($this->table, ['status' => ConfessionTable::STATUS_NORMAL], [], $page, $row);
    }
}
