<?php
namespace dxkite\confession\wall\provider;

use dxkite\confession\wall\controller\ConfessionController;

/**
 * 处理表白
 */
class ConfessionProvider
{
    protected $controller;

    public function __construct()
    {
        $this->controller = new ConfessionController;
    }

    public function add(string $title, string $content, bool $anonymous=true): int
    {
        return $this->controller->add($title, $content, $anonymous);
    }

    public function list(?int $page, int $row = 10):?array
    {
        $pageData = $this->controller->list($page, $row);
        $pageRows = $pageData['rows']; // 获取到数据字段
        // 检测到需要处理的用户ID
        $userIdMap = [];
        foreach ($pageRows as $index => $pageRow) {
            // 表示匿名状态
            if ($pageRow['anonymous'] == 1) {
                // 清理user的信息
                $pageRow['user'] = 0;
            } else {
                // 记录ID信息
                // ID => 索引
                $userIdMap[$pageRow['user']]=$index;
            }
            // 去除IP信息
            unset($pageRow['ip']);
            // 替换原来的列
            $pageRows[$index] = $pageRow;
        }
        // 获取所有用户信息
        $userInfos = get_user_public_info_array(array_keys($userIdMap));
        // 返回到数据列
        foreach ($userInfos as $id => $data) {
            // $userIdMap[$id] == index
            $pageRows[$userIdMap[$id]]['user']=$data;
        }
        // 放回原来的字段
        $pageData['rows'] = $pageRows;
        return $pageData;
    }
}
